"""
Django settings for planner_public_backend project.

Generated by 'django-admin startproject' using Django 3.0.8.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

from typing import Optional

import environ

env = environ.Env()

SRC_DIR = environ.Path(__file__) - 3
PROJECT_DIR = SRC_DIR - 1
REPO_DIR = PROJECT_DIR - 1

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
# You can generate one usign the following command:
#   python -c 'import random, string; print("".join(random.choice(string.ascii_letters) for _ in range(54)))'
# SECRET_KEY = "some securely random string"

# Application definition

INSTALLED_APPS = [
    # Django
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    # 3rd party
    "webpack_loader",
    "phonenumber_field",
    # Ours
    "applications",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

ROOT_URLCONF = "planner_public_backend.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "planner_public_backend.context_processors.skip_js",
                "planner_public_backend.context_processors.env_warning",
                "planner_public_backend.context_processors.features",
            ],
        },
    },
]

WSGI_APPLICATION = "planner_public_backend.wsgi.application"


# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {"NAME": "django.contrib.auth.password_validation.MinimumLengthValidator"},
    {"NAME": "django.contrib.auth.password_validation.CommonPasswordValidator"},
    {"NAME": "django.contrib.auth.password_validation.NumericPasswordValidator"},
]

# Default id field
DEFAULT_AUTO_FIELD = "django.db.models.AutoField"


# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_TZ = True

# Phone number representation in databse. Can be one of 'E164', 'INTERNATIONAL', 'NATIONAL' or 'RFC3966'

PHONENUMBER_DB_FORMAT = "E164"


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATIC_URL = "/static/"

# This needs to be overridden with the missing fields filled in in specific settings
WEBPACK_LOADER_DEFAULT_DEFAULTS = {
    # "CACHE": True,
    "BUNDLE_DIR_NAME": "compiled/",
    # "STATS_FILE": "/path/to/webpack-stats.json",
    "IGNORE": [r".+\.hot-update.js", r".+\.map"],
    "POLL_INTERVAL": 0.1,
    "TIMEOUT": None,
    "LOADER_CLASS": "webpack_loader.loader.WebpackLoader",
}

# EMAIL defaults
# SUBJECT PREFIX FOR INTERNAL MAIL
EMAIL_SUBJECT_PREFIX = env.get_value(
    "EMAIL_SUBJECT_PREFIX", default="[Crewing planner]", cast=str
)

SHOW_ENV_WARNING: Optional[str] = None
